curl --request POST \
--url https://api.qa.tech/v1/chat/change-review \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"mode": "pr",
"applicationOverrides": [
{
"applicationShortId": "<string>",
"environment": {
"url": "<string>",
"name": "<string>",
"customHeaders": [
{
"domains": [
"<string>"
],
"headers": {}
}
],
"basicAuth": [
{
"domains": [
"<string>"
],
"username": "<string>",
"password": "<string>"
}
]
},
"devicePresetShortId": "<string>",
"issueReporters": {
"accessibility": {
"enabled": true,
"tags": [
"<string>"
],
"disabledRules": [
"<string>"
],
"includeIncomplete": true,
"iframes": true
},
"performance": {
"enabled": true
}
}
}
],
"prUrl": "<string>",
"context": "<string>",
"forceNewConversation": false,
"triage": {
"enabled": true,
"prompt": "<string>"
},
"disableReviewComments": true,
"actor": "<string>",
"branch": "<string>",
"commitHash": "<string>",
"commitMessage": "<string>",
"repository": "<string>",
"projectShortId": "<string>"
}
'import requests
url = "https://api.qa.tech/v1/chat/change-review"
payload = {
"mode": "pr",
"applicationOverrides": [
{
"applicationShortId": "<string>",
"environment": {
"url": "<string>",
"name": "<string>",
"customHeaders": [
{
"domains": ["<string>"],
"headers": {}
}
],
"basicAuth": [
{
"domains": ["<string>"],
"username": "<string>",
"password": "<string>"
}
]
},
"devicePresetShortId": "<string>",
"issueReporters": {
"accessibility": {
"enabled": True,
"tags": ["<string>"],
"disabledRules": ["<string>"],
"includeIncomplete": True,
"iframes": True
},
"performance": { "enabled": True }
}
}
],
"prUrl": "<string>",
"context": "<string>",
"forceNewConversation": False,
"triage": {
"enabled": True,
"prompt": "<string>"
},
"disableReviewComments": True,
"actor": "<string>",
"branch": "<string>",
"commitHash": "<string>",
"commitMessage": "<string>",
"repository": "<string>",
"projectShortId": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
mode: 'pr',
applicationOverrides: [
{
applicationShortId: '<string>',
environment: {
url: '<string>',
name: '<string>',
customHeaders: [{domains: ['<string>'], headers: {}}],
basicAuth: [{domains: ['<string>'], username: '<string>', password: '<string>'}]
},
devicePresetShortId: '<string>',
issueReporters: {
accessibility: {
enabled: true,
tags: ['<string>'],
disabledRules: ['<string>'],
includeIncomplete: true,
iframes: true
},
performance: {enabled: true}
}
}
],
prUrl: '<string>',
context: '<string>',
forceNewConversation: false,
triage: {enabled: true, prompt: '<string>'},
disableReviewComments: true,
actor: '<string>',
branch: '<string>',
commitHash: '<string>',
commitMessage: '<string>',
repository: '<string>',
projectShortId: '<string>'
})
};
fetch('https://api.qa.tech/v1/chat/change-review', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.qa.tech/v1/chat/change-review",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'mode' => 'pr',
'applicationOverrides' => [
[
'applicationShortId' => '<string>',
'environment' => [
'url' => '<string>',
'name' => '<string>',
'customHeaders' => [
[
'domains' => [
'<string>'
],
'headers' => [
]
]
],
'basicAuth' => [
[
'domains' => [
'<string>'
],
'username' => '<string>',
'password' => '<string>'
]
]
],
'devicePresetShortId' => '<string>',
'issueReporters' => [
'accessibility' => [
'enabled' => true,
'tags' => [
'<string>'
],
'disabledRules' => [
'<string>'
],
'includeIncomplete' => true,
'iframes' => true
],
'performance' => [
'enabled' => true
]
]
]
],
'prUrl' => '<string>',
'context' => '<string>',
'forceNewConversation' => false,
'triage' => [
'enabled' => true,
'prompt' => '<string>'
],
'disableReviewComments' => true,
'actor' => '<string>',
'branch' => '<string>',
'commitHash' => '<string>',
'commitMessage' => '<string>',
'repository' => '<string>',
'projectShortId' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.qa.tech/v1/chat/change-review"
payload := strings.NewReader("{\n \"mode\": \"pr\",\n \"applicationOverrides\": [\n {\n \"applicationShortId\": \"<string>\",\n \"environment\": {\n \"url\": \"<string>\",\n \"name\": \"<string>\",\n \"customHeaders\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"headers\": {}\n }\n ],\n \"basicAuth\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"username\": \"<string>\",\n \"password\": \"<string>\"\n }\n ]\n },\n \"devicePresetShortId\": \"<string>\",\n \"issueReporters\": {\n \"accessibility\": {\n \"enabled\": true,\n \"tags\": [\n \"<string>\"\n ],\n \"disabledRules\": [\n \"<string>\"\n ],\n \"includeIncomplete\": true,\n \"iframes\": true\n },\n \"performance\": {\n \"enabled\": true\n }\n }\n }\n ],\n \"prUrl\": \"<string>\",\n \"context\": \"<string>\",\n \"forceNewConversation\": false,\n \"triage\": {\n \"enabled\": true,\n \"prompt\": \"<string>\"\n },\n \"disableReviewComments\": true,\n \"actor\": \"<string>\",\n \"branch\": \"<string>\",\n \"commitHash\": \"<string>\",\n \"commitMessage\": \"<string>\",\n \"repository\": \"<string>\",\n \"projectShortId\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.qa.tech/v1/chat/change-review")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"mode\": \"pr\",\n \"applicationOverrides\": [\n {\n \"applicationShortId\": \"<string>\",\n \"environment\": {\n \"url\": \"<string>\",\n \"name\": \"<string>\",\n \"customHeaders\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"headers\": {}\n }\n ],\n \"basicAuth\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"username\": \"<string>\",\n \"password\": \"<string>\"\n }\n ]\n },\n \"devicePresetShortId\": \"<string>\",\n \"issueReporters\": {\n \"accessibility\": {\n \"enabled\": true,\n \"tags\": [\n \"<string>\"\n ],\n \"disabledRules\": [\n \"<string>\"\n ],\n \"includeIncomplete\": true,\n \"iframes\": true\n },\n \"performance\": {\n \"enabled\": true\n }\n }\n }\n ],\n \"prUrl\": \"<string>\",\n \"context\": \"<string>\",\n \"forceNewConversation\": false,\n \"triage\": {\n \"enabled\": true,\n \"prompt\": \"<string>\"\n },\n \"disableReviewComments\": true,\n \"actor\": \"<string>\",\n \"branch\": \"<string>\",\n \"commitHash\": \"<string>\",\n \"commitMessage\": \"<string>\",\n \"repository\": \"<string>\",\n \"projectShortId\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.qa.tech/v1/chat/change-review")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"mode\": \"pr\",\n \"applicationOverrides\": [\n {\n \"applicationShortId\": \"<string>\",\n \"environment\": {\n \"url\": \"<string>\",\n \"name\": \"<string>\",\n \"customHeaders\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"headers\": {}\n }\n ],\n \"basicAuth\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"username\": \"<string>\",\n \"password\": \"<string>\"\n }\n ]\n },\n \"devicePresetShortId\": \"<string>\",\n \"issueReporters\": {\n \"accessibility\": {\n \"enabled\": true,\n \"tags\": [\n \"<string>\"\n ],\n \"disabledRules\": [\n \"<string>\"\n ],\n \"includeIncomplete\": true,\n \"iframes\": true\n },\n \"performance\": {\n \"enabled\": true\n }\n }\n }\n ],\n \"prUrl\": \"<string>\",\n \"context\": \"<string>\",\n \"forceNewConversation\": false,\n \"triage\": {\n \"enabled\": true,\n \"prompt\": \"<string>\"\n },\n \"disableReviewComments\": true,\n \"actor\": \"<string>\",\n \"branch\": \"<string>\",\n \"commitHash\": \"<string>\",\n \"commitMessage\": \"<string>\",\n \"repository\": \"<string>\",\n \"projectShortId\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"shortId": "<string>",
"url": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"updatedAt": "2023-11-07T05:31:56Z",
"status": "in_progress",
"runs": [
{
"shortId": "<string>",
"status": "<string>",
"result": "<string>",
"url": "<string>"
}
],
"title": "<string>",
"source": "api",
"messages": [
{
"id": "<string>",
"role": "user",
"createdAt": "2023-11-07T05:31:56Z",
"text": "<string>",
"status": "INITIATED",
"isStreaming": true
}
]
}Start change review chat
Start an autonomous change review from either a PR URL or raw change input. Returns 202 with the review conversation.
PR mode reuses the pull request’s existing review conversation unless forceNewConversation is true or that conversation is archived.
For a GitHub pull request’s head commit:
- If a
POST /chat/change-review/preparerequest left a review waiting, this request runs its tests againstapplicationOverridesin the same conversation, with this request’scontext. - Otherwise it runs a full review.
- If PR triage skipped the commit, it does nothing unless it sends
triage.enabled: falseor a review was requested with@qa.tech.
Send commitHash from CI (pull_request.head.sha) when calling from GitHub Actions so triage, prepare, and this request key off the commit the workflow is building. QA.tech uses it for review state and updates the stored pull request head when webhooks lag.
In every case the response is the review conversation. Poll get_chat_conversation until its status is completed, failed, or cancelled.
curl --request POST \
--url https://api.qa.tech/v1/chat/change-review \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"mode": "pr",
"applicationOverrides": [
{
"applicationShortId": "<string>",
"environment": {
"url": "<string>",
"name": "<string>",
"customHeaders": [
{
"domains": [
"<string>"
],
"headers": {}
}
],
"basicAuth": [
{
"domains": [
"<string>"
],
"username": "<string>",
"password": "<string>"
}
]
},
"devicePresetShortId": "<string>",
"issueReporters": {
"accessibility": {
"enabled": true,
"tags": [
"<string>"
],
"disabledRules": [
"<string>"
],
"includeIncomplete": true,
"iframes": true
},
"performance": {
"enabled": true
}
}
}
],
"prUrl": "<string>",
"context": "<string>",
"forceNewConversation": false,
"triage": {
"enabled": true,
"prompt": "<string>"
},
"disableReviewComments": true,
"actor": "<string>",
"branch": "<string>",
"commitHash": "<string>",
"commitMessage": "<string>",
"repository": "<string>",
"projectShortId": "<string>"
}
'import requests
url = "https://api.qa.tech/v1/chat/change-review"
payload = {
"mode": "pr",
"applicationOverrides": [
{
"applicationShortId": "<string>",
"environment": {
"url": "<string>",
"name": "<string>",
"customHeaders": [
{
"domains": ["<string>"],
"headers": {}
}
],
"basicAuth": [
{
"domains": ["<string>"],
"username": "<string>",
"password": "<string>"
}
]
},
"devicePresetShortId": "<string>",
"issueReporters": {
"accessibility": {
"enabled": True,
"tags": ["<string>"],
"disabledRules": ["<string>"],
"includeIncomplete": True,
"iframes": True
},
"performance": { "enabled": True }
}
}
],
"prUrl": "<string>",
"context": "<string>",
"forceNewConversation": False,
"triage": {
"enabled": True,
"prompt": "<string>"
},
"disableReviewComments": True,
"actor": "<string>",
"branch": "<string>",
"commitHash": "<string>",
"commitMessage": "<string>",
"repository": "<string>",
"projectShortId": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
mode: 'pr',
applicationOverrides: [
{
applicationShortId: '<string>',
environment: {
url: '<string>',
name: '<string>',
customHeaders: [{domains: ['<string>'], headers: {}}],
basicAuth: [{domains: ['<string>'], username: '<string>', password: '<string>'}]
},
devicePresetShortId: '<string>',
issueReporters: {
accessibility: {
enabled: true,
tags: ['<string>'],
disabledRules: ['<string>'],
includeIncomplete: true,
iframes: true
},
performance: {enabled: true}
}
}
],
prUrl: '<string>',
context: '<string>',
forceNewConversation: false,
triage: {enabled: true, prompt: '<string>'},
disableReviewComments: true,
actor: '<string>',
branch: '<string>',
commitHash: '<string>',
commitMessage: '<string>',
repository: '<string>',
projectShortId: '<string>'
})
};
fetch('https://api.qa.tech/v1/chat/change-review', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.qa.tech/v1/chat/change-review",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'mode' => 'pr',
'applicationOverrides' => [
[
'applicationShortId' => '<string>',
'environment' => [
'url' => '<string>',
'name' => '<string>',
'customHeaders' => [
[
'domains' => [
'<string>'
],
'headers' => [
]
]
],
'basicAuth' => [
[
'domains' => [
'<string>'
],
'username' => '<string>',
'password' => '<string>'
]
]
],
'devicePresetShortId' => '<string>',
'issueReporters' => [
'accessibility' => [
'enabled' => true,
'tags' => [
'<string>'
],
'disabledRules' => [
'<string>'
],
'includeIncomplete' => true,
'iframes' => true
],
'performance' => [
'enabled' => true
]
]
]
],
'prUrl' => '<string>',
'context' => '<string>',
'forceNewConversation' => false,
'triage' => [
'enabled' => true,
'prompt' => '<string>'
],
'disableReviewComments' => true,
'actor' => '<string>',
'branch' => '<string>',
'commitHash' => '<string>',
'commitMessage' => '<string>',
'repository' => '<string>',
'projectShortId' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.qa.tech/v1/chat/change-review"
payload := strings.NewReader("{\n \"mode\": \"pr\",\n \"applicationOverrides\": [\n {\n \"applicationShortId\": \"<string>\",\n \"environment\": {\n \"url\": \"<string>\",\n \"name\": \"<string>\",\n \"customHeaders\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"headers\": {}\n }\n ],\n \"basicAuth\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"username\": \"<string>\",\n \"password\": \"<string>\"\n }\n ]\n },\n \"devicePresetShortId\": \"<string>\",\n \"issueReporters\": {\n \"accessibility\": {\n \"enabled\": true,\n \"tags\": [\n \"<string>\"\n ],\n \"disabledRules\": [\n \"<string>\"\n ],\n \"includeIncomplete\": true,\n \"iframes\": true\n },\n \"performance\": {\n \"enabled\": true\n }\n }\n }\n ],\n \"prUrl\": \"<string>\",\n \"context\": \"<string>\",\n \"forceNewConversation\": false,\n \"triage\": {\n \"enabled\": true,\n \"prompt\": \"<string>\"\n },\n \"disableReviewComments\": true,\n \"actor\": \"<string>\",\n \"branch\": \"<string>\",\n \"commitHash\": \"<string>\",\n \"commitMessage\": \"<string>\",\n \"repository\": \"<string>\",\n \"projectShortId\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.qa.tech/v1/chat/change-review")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"mode\": \"pr\",\n \"applicationOverrides\": [\n {\n \"applicationShortId\": \"<string>\",\n \"environment\": {\n \"url\": \"<string>\",\n \"name\": \"<string>\",\n \"customHeaders\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"headers\": {}\n }\n ],\n \"basicAuth\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"username\": \"<string>\",\n \"password\": \"<string>\"\n }\n ]\n },\n \"devicePresetShortId\": \"<string>\",\n \"issueReporters\": {\n \"accessibility\": {\n \"enabled\": true,\n \"tags\": [\n \"<string>\"\n ],\n \"disabledRules\": [\n \"<string>\"\n ],\n \"includeIncomplete\": true,\n \"iframes\": true\n },\n \"performance\": {\n \"enabled\": true\n }\n }\n }\n ],\n \"prUrl\": \"<string>\",\n \"context\": \"<string>\",\n \"forceNewConversation\": false,\n \"triage\": {\n \"enabled\": true,\n \"prompt\": \"<string>\"\n },\n \"disableReviewComments\": true,\n \"actor\": \"<string>\",\n \"branch\": \"<string>\",\n \"commitHash\": \"<string>\",\n \"commitMessage\": \"<string>\",\n \"repository\": \"<string>\",\n \"projectShortId\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.qa.tech/v1/chat/change-review")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"mode\": \"pr\",\n \"applicationOverrides\": [\n {\n \"applicationShortId\": \"<string>\",\n \"environment\": {\n \"url\": \"<string>\",\n \"name\": \"<string>\",\n \"customHeaders\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"headers\": {}\n }\n ],\n \"basicAuth\": [\n {\n \"domains\": [\n \"<string>\"\n ],\n \"username\": \"<string>\",\n \"password\": \"<string>\"\n }\n ]\n },\n \"devicePresetShortId\": \"<string>\",\n \"issueReporters\": {\n \"accessibility\": {\n \"enabled\": true,\n \"tags\": [\n \"<string>\"\n ],\n \"disabledRules\": [\n \"<string>\"\n ],\n \"includeIncomplete\": true,\n \"iframes\": true\n },\n \"performance\": {\n \"enabled\": true\n }\n }\n }\n ],\n \"prUrl\": \"<string>\",\n \"context\": \"<string>\",\n \"forceNewConversation\": false,\n \"triage\": {\n \"enabled\": true,\n \"prompt\": \"<string>\"\n },\n \"disableReviewComments\": true,\n \"actor\": \"<string>\",\n \"branch\": \"<string>\",\n \"commitHash\": \"<string>\",\n \"commitMessage\": \"<string>\",\n \"repository\": \"<string>\",\n \"projectShortId\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"shortId": "<string>",
"url": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"updatedAt": "2023-11-07T05:31:56Z",
"status": "in_progress",
"runs": [
{
"shortId": "<string>",
"status": "<string>",
"result": "<string>",
"url": "<string>"
}
],
"title": "<string>",
"source": "api",
"messages": [
{
"id": "<string>",
"role": "user",
"createdAt": "2023-11-07T05:31:56Z",
"text": "<string>",
"status": "INITIATED",
"isStreaming": true
}
]
}Body
- Option 1
- Option 2
Request body for starting a change review chat
When true, the agent does not post its review comments to the pull request. The review still runs and is stored in QA.tech, and the GitHub check run is still reported. Use it when you do not want comments on the PR, for example during evaluation. Stored on the review conversation, so later reviews of this PR also stay silent until a request sends false. Omit to keep the conversation's current setting (comments are posted by default).
Response
The request has been accepted for processing, but processing has not yet completed.
Conversation data with recent messages (newest first).
Overall conversation lifecycle. in_progress while the assistant is working or a background test run / research task is still going. Assistant message COMPLETED is not enough — starting a run ends the current turn. Poll until this is completed, failed, or cancelled.
in_progress, completed, failed, cancelled Was this page helpful?